## Papers We Love

Repository related to the following meetups:

* [NYC - Papers We Love](http://www.meetup.com/papers-we-love/)
* [SF - Papers We Love too](http://www.meetup.com/papers-we-love-too/)
* [London - Papers We Love](http://www.meetup.com/papers-we-love-london)
* [Saint Louis - Papers We Love](http://www.meetup.com/Papers-We-Love-in-saint-louis/)
* [Colorado - Papers We Love](http://www.meetup.com/Papers-We-Love-Boulder/)

Let us know if you are interested in starting a [chapter](https://github.com/papers-we-love/papers-we-love/wiki/Creating-a-PWL-chapter)!

### Past Presentations

* Our latest presentation was led by [Michael Bernstein](http://michaelrbernste.in/) on [A Unified Theory of Garbage Collection](http://www.youtube.com/watch?v=XtUtfARSIv8)

See the complete list of [past presentations](https://github.com/papers-we-love/papers-we-love/wiki/Past-Presentations) or check out our Youtube [channel](http://www.youtube.com/user/PapersWeLove)

## Info

We're looking for pull requests related to papers we should add, better organization of the papers we do have, and/or links to other paper-repos we should point to.

### Other Good Places to Find Papers

* [Best Paper Awards in Computer Science](http://jeffhuang.com/best_paper_awards.html)
* [Facebook](https://www.facebook.com/publications)
* [Google Scholar](http://scholar.google.com/citations?view_op=top_venues&hl=en&vq=eng) (choose a subcategory)
* [Microsoft](http://research.microsoft.com/apps/catalog/default.aspx?t=publications)
* [Vijay D'Silva](http://www.eecs.berkeley.edu/~vijayd/#papers)
* [Functional Programming Books Review](http://alexott.net/en/fp/books/)
* [MIT's Distributed System's Reading Group](http://pdos.csail.mit.edu/dsrg/)
* [arXiv Paper Repository](http://arxiv.org/)
* [SciRate](https://scirate.com/)
* [cat-v.org](http://doc.cat-v.org/)
* [y-archive](http://yarchive.net/comp/index.html)
* [Bell System Technical Journal](http://www3.alcatel-lucent.com/bstj/)
* [netlib](http://www.netlib.org/)

Please check out our [wiki-page](https://github.com/papers-we-love/papers-we-love/wiki/Other-Good-Sources-of-Reading-Material) for links to blogs, books, exchanges that are worth a good read.

### How To Read a Paper

Reading a paper is not the same as reading a blogpost or a novel. Here are a few handy resources to help you get started.

* [How to read an academic article](http://organizationsandmarkets.com/2010/08/31/how-to-read-an-academic-article/)
* [Advice on reading academic papers](http://www4.ncsu.edu/~akmassey/posts/2012-02-15-advice-on-reading-academic-papers.html)
* [How to read and understand a scientific paper](http://violentmetaphors.com/2013/08/25/how-to-read-and-understand-a-scientific-paper-2/)

## Contributing Guidelines

We have a few guidelines in place to keep the repo clean and easy to navigate. We recommend that you follow these conventions in your pull-request for a speedy merge. Note that every pull request we receive must have Two-Thumbs-Up minimum from PWL organizers/collaborators to be merged.

### Follow the group's ethos

We want to help bring academic research closer to practitioners and we strive to:
* **Keep the quality of papers listed high:** Books, blogposts, and/or reference pdfs don't go through the same review process that academic papers do and we won't add them to this repo.
* **Help people understand why a paper is important:** We ask that you include with your commit an update to the directory README with a short justification of why you love this paper (for example: A paper might be interesting because it spawned a new domain, it was exceptionally well-written, or perhaps it was completely wrong about something.)

### Respect content licenses

* **We will only merge pull requests that contain research papers that allow digital distribution.** Papers whose copyright prohibits redistribution will not be accepted; for example [license 1](http://www.acm.org/publications/policies/copyright-policy-v1) from the [ACM digital library](http://www.acm.org/publications/policies/copyright_policy).
* We encourage papers that do not allow digital distribution to be added to a README in the appropriate subject's folder. For example, [the distributed systems README](https://github.com/papers-we-love/papers-we-love/blob/master/distributed_systems/README.md).

### Follow our naming convention

* Directory names are undercased and separated by underscores (example: artificial_intelligence)
* Paper names are undercased and separated by dashes (example: out-of-the-tar-pit.pdf). Use the full title when possible.
